<?php

function get_objects_by_metadata($meta_type, $meta_key, $meta_value = '') {
	if ( !$meta_type || !$meta_key )
		return false;

	if ( ! $table = _get_meta_table($meta_type) )
		return false;

	global $wpdb;

	$type_column = esc_sql($meta_type . '_id');
	$meta_key = stripslashes($meta_key);

	$query = $wpdb->prepare( "SELECT $type_column FROM $table WHERE meta_key = %s", $meta_key );

	if ( $meta_value )
		$query .= $wpdb->prepare( " AND meta_value = %s", $meta_value );

	$object_ids = $wpdb->get_col( $query );

	$objects = array();

	foreach ( (array) $object_ids as $id ) {
		$objects[]= apply_filters("fill_object_$meta_type", false, $id);
	}

	return array_filter($objects);
}


function _fill_object_comment($comment, $id) {
	return get_comment($id);
}
add_filter('fill_object_comment', '_fill_object_comment', 10, 2);


function _fill_object_post($post, $id) {
	return get_post($id);
}
add_filter('fill_object_post', '_fill_object_post', 10, 2);


function _fill_object_user($user, $id) {
	return get_userdata($id);
}
add_filter('fill_object_user', '_fill_object_user', 10, 2);

?>
